

function [ Kernel_train Kernel_test ] = compute_Kernel(KERNEL_FUN, Xo, SV, gamma, C_class, dir_kernel)
  
N_datasets = length(Xo);

ct = clock;

switch KERNEL_FUN
    
    case 'DE'
 
        fprintf ('\n[%04d/%02d/%02d %02d:%02d] ', ct(1), ct(2), ct(3), ct(4), ct(5));
        fprintf ('Computing Kernel DE , g %.5f , rdim %d ... ', Nclusters, gamma, size(Xo{1},2)); tic
 
        Kernel = compute_kernel_DE(Xo, Xo, gamma);
        Kernel_train = Kernel;
        Kernel_test = Kernel;

        %-- save 
        kernel_filename=sprintf('%s/kernel_all_g%.5f.mat', dir_kernel, gamma)
        save(kernel_filename,'Kernel_all');
        h = figure('visible','off');
        imagesc(Kernel_all), colorbar
        saveas(h,[kernel_filename(1:length(kernel_filename)-4) '.png']);
    
    case 'DE-SV'

        fprintf ('\n[%04d/%02d/%02d %02d:%02d] ', ct(1), ct(2), ct(3), ct(4), ct(5));
        fprintf ('Computing Kernel DE-SV train , g %.5f , rdim %d ...', gamma, size(Xo{1},2)); tic
        
        %// use SV from N source users
        Kernel_train = compute_kernel_DE(SV, SV, gamma);
        
        fprintf ('\n[%04d/%02d/%02d %02d:%02d] ', ct(1), ct(2), ct(3), ct(4), ct(5));
        fprintf ('Computing Kernel DE-SV test , g %.5f , rdim %d ...', gamma, size(Xo{1},2)); tic
        
        %// use SV from N source users, use all_points from target user
        Kernel_test = compute_kernel_DE(Xo, SV, gamma); 
       
        %-- save
        kernel_filename_train=sprintf('%s/kernel_sv_g%.5f_cC%5f_train.mat', dir_kernel, gamma, C_class);
        kernel_filename_test=sprintf('%s/kernel_sv_g%.5f_cC%5f_test.mat', dir_kernel, gamma, C_class);

        save(kernel_filename_train,'Kernel_train');
        h = figure('visible','off');
        imagesc(Kernel_train), colorbar
        saveas(h,[kernel_filename_train(1:length(kernel_filename_train)-4) '.png']);
 
        save(kernel_filename_test,'Kernel_test');
        h = figure('visible','off');
        imagesc(Kernel_test), colorbar
        saveas(h,[kernel_filename_test(1:length(kernel_filename_test)-4) '.png']);
        
    otherwise

        fprintf('\n\n[ERROR] Kernel_fun <%s> is not defined. \n\n', KERNEL_FUN);
        Kernel_train = [];
        Kernel_test = [];
        return;     
        
        
end
    



